Subject: Re: bug#17147: Performance regression by 3000000% for evaluating "and" form

From: David Kastrup <[email-masked]>
Date: Tue, 01 Apr 2014 13:59:02 +0200

David Kastrup <[email-masked]> writes:

> If Guile is not going to optimize ..., I think it would be good if it
> led by example (its sources _are_ going to teach people how to program)
> and simply avoided using ... altogether, at the very least where
> recursive expansion rules are concerned.
>
> I have the suspicion, however, that there are a lot of tutorials/etc in
> the wild that do make use of ellipses.  So while avoiding ... will help
> with keeping Guile's own internals scalable to large expressions, it
> will still likely affect the performance of a significant amount of
> third-party code.

By the way: module/system/vm/assembler.scm is taking an absolutely
insane amount of time to compile.  It also makes copious use of syntax
rules including ... and this might be related.

-- 
David Kastrup